import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
/**
* Sliders panel displaying perspective coeficients.
*/
public class OntoSliders extends JPanel implements 
        ChangeListener, MouseListener, ItemListener, ActionListener{
   OntoApp oa;
   int currentNr=-1;
   JLabel[] labels;
   JSlider[] sliders;
//   JSlider[] namesliders; //Yhe rea omaduste jaoks
   JProgressBar[] namesliders;
   JSlider masterSlider=new JSlider(0, 100, 0);
   boolean wasNull=true;
   JLabel lab1=new JLabel("Self");
   JLabel lab2=new JLabel("View");
   JComboBox cmbusernames=new JComboBox();
   JButton bsavesettings=new JButton("Save parameters");
   String currentusername="Not user";
//   JTextField[] stfs;
   public OntoSliders(OntoApp oa){
      this.oa=oa;   
   }
   public void initialize(){
      int masterNr=(oa.odf.bzmasterview.isSelected()?4:1000000); //Sellest alates nidatakse 
      removeAll();
//      setLayout(new GridLayout(oa.od.parameters.length+((oa.od.parameters.length>masterNr)?1:0),1));
      setLayout(new GridLayout(oa.od.params.length+((oa.od.params.length>masterNr)?1:0)+(oa.odf.bznameslidersview.isSelected()?1:0)+
                              (oa.odf.bzuserslidersview.isSelected()?1:0),1));
      labels=new JLabel[oa.od.params.length];
      sliders=new JSlider[oa.od.params.length];
//      namesliders=new JSlider[oa.od.params.length];
      namesliders=new JProgressBar[oa.od.params.length];
//      stfs=new JTextField[oa.od.params.length];
      if(oa.odf.bzuserslidersview.isSelected()){
         JPanel pu=new JPanel(new GridLayout(1, 2));
         pu.add(cmbusernames);
         pu.add(bsavesettings);
         add(pu);
         cmbusernames.addItemListener(this);
         bsavesettings.addActionListener(this);
      }
      if(sliders.length>masterNr){
         masterSlider=new JSlider(0, 100, 0);
         JPanel p=new JPanel(new BorderLayout());
         JPanel p2=new JPanel(new BorderLayout());
         p2.add(masterSlider, BorderLayout.CENTER);
         p2.add(new JLabel("   "), BorderLayout.EAST);
         p.add(p2, BorderLayout.SOUTH);
         p.add(new JLabel("Master slider"), BorderLayout.NORTH);
         masterSlider.addChangeListener(this);  
         add(p);       
      }
      if(oa.odf.bznameslidersview.isSelected()){
         JPanel p=new JPanel(new BorderLayout());
         p.add(new JLabel("Parameter"));
         JPanel p2=new JPanel(new GridLayout(1, 2));
         lab1.setPreferredSize(new Dimension(70, 20));
         lab2.setPreferredSize(new Dimension(70, 20));
         p2.add(lab1);
         p2.add(lab2);
         p.add(p2, BorderLayout.EAST);
         add(p);
      }
      for(int i=0; i<oa.od.params.length; i++){
         sliders[i]=new JSlider(0, 100, (int)(100*oa.od.params[i].coef));
//         namesliders[i]=new JSlider(0, 100, 0);
         namesliders[i]=new JProgressBar(0, 100);
         namesliders[i].setForeground(Color.green);
//         sliders[i]=new JSlider(0, 100, (int)(100*oa.od.perspective[i]));
//         stfs[i]=new JTextField(oa.od.perspective[i]+"", 4);
//         stfs[i]=new JTextField(oa.od.params[i].coef+"", 4);
//         JPanel p=new JPanel(new GridLayout(1, 3));
         JPanel p=new JPanel(new BorderLayout());
//         JPanel p2=new JPanel(new BorderLayout());
         JLabel slbl=new JLabel(oa.od.params[i].name);
         labels[i]=slbl;
         labels[i].addMouseListener(this);
         sliders[i].addMouseListener(this);
         namesliders[i].addMouseListener(this);
         slbl.setToolTipText(oa.od.params[i].name);
         p.add(slbl);
         if(oa.odf.bznameslidersview.isSelected()){
            JPanel sp=new JPanel(new GridLayout(1, 2));
            sp.add(sliders[i]);
            sp.add(namesliders[i]);
            namesliders[i].setPreferredSize(new Dimension(70, 20));
            p.add(sp, BorderLayout.EAST);      
         } else {
            p.add(sliders[i], BorderLayout.EAST);         
         }
         sliders[i].setToolTipText(oa.od.params[i].name);
         sliders[i].setPreferredSize(new Dimension(70, 20));
//         p.add(new JLabel("   "));
         //p.add(p2, BorderLayout.SOUTH);
         //p.add(stfs[i], BorderLayout.EAST);
         add(p);
//         sliders[i].setPaintLabels(true);
//         sliders[i].setPaintTicks(true);
//         sliders[i].setPaintTrack(true);
         sliders[i].addChangeListener(this);
      }
     if(!oa.isStandalone){
       String filename="getCurrentUserName";
       System.out.println(filename);
       try{
         BufferedReader br=new BufferedReader(new InputStreamReader(
          new URL(oa.getCodeBase(), filename).openStream()));
         currentusername=br.readLine();
         System.out.println(currentusername);
         filename="getUserNamesAsText";
         System.out.println(filename);
         br=new BufferedReader(new InputStreamReader(
          new URL(oa.getCodeBase(), filename).openStream()));
         String usernames=br.readLine();
         System.out.println(usernames);
         cmbusernames.removeAllItems();
         StringTokenizer stk=new StringTokenizer(usernames);
         while(stk.hasMoreTokens()){
            String uname=stk.nextToken();
            cmbusernames.addItem(uname);
            System.out.println("Lisati "+uname);
         }
         cmbusernames.setSelectedItem(currentusername);
       }catch(Exception ex){
         ex.printStackTrace();
       }
      }

      validate();
   }

   public void mousePressed(MouseEvent e){}
   public void mouseReleased(MouseEvent e){
     oa.repaint();
   }
   public void mouseEntered(MouseEvent e){
      for(int i=0; i<labels.length; i++){
         if(e.getSource()==labels[i] || e.getSource()==sliders[i] 
          ||e.getSource()==namesliders[i]){
            currentNr=i;
            oa.repaint();
         }
      }
   }
   public void mouseExited(MouseEvent e){
       currentNr=-1;
       oa.repaint();
   }
   public void mouseClicked(MouseEvent e){}

   public Dimension getPreferredSize(){
      return new Dimension(270, (30*sliders.length+20 > oa.getHeight())?30*sliders.length+20:oa.getHeight()-50);
   }

   boolean bigMoving=false;
   
   void resetSliders(){
         bigMoving=true;
       for(int i=0; i<sliders.length; i++){
          sliders[i].setValue(0);
       }  
         bigMoving=false;
       masterSlider.setValue(0);      
   }
   
   public void stateChanged(ChangeEvent e){
    if(e.getSource()==masterSlider){
         bigMoving=true;
       for(int i=0; i<sliders.length; i++){
          sliders[i].setValue(masterSlider.getValue());
       }  
         bigMoving=false;
    }
    useSliderValues();
//    oa.addTree();
   }
   
   void useSliderValues(){
    boolean isNull=true;
    for(int i=0; i<sliders.length; i++){
        if(sliders[i].getValue()!=0){isNull=false;}
        oa.od.params[i].coef=sliders[i].getValue()/100.0;
    }
    if(isNull){
      oa.od.nullCoordinates();
      wasNull=true;
      oa.op.calculateKoef();
      oa.op.repaint(1000);
      System.out.println("alg");
      revalidate();
      oa.repaint();
    } else {
     if(oa.odf.brautomcalc.isSelected() && !bigMoving){
       if(wasNull){oa.od.randomCoordinates(); wasNull=false;}
       oa.ol.iterateN(Integer.parseInt(oa.btf1.getText()));
       //saveSliderSettings();
     }
    }   
   }
   
   void saveSliderSettings(){
     if(sliders.length==0){return;}
     String t="p="+sliders[0].getValue()/100.0;
     for(int i=1; i<sliders.length; i++){
       t+="&p="+(sliders[i].getValue()/100.0);
     }
     String filename="setUserParameterValues?"+t;
     System.out.println(filename);
     if(!oa.isStandalone && cmbusernames.getSelectedItem().equals(currentusername)){
       try{
         BufferedReader br=new BufferedReader(new InputStreamReader(
          new URL(oa.getCodeBase(), filename).openStream()));
         System.out.println(br.readLine());
       }catch(Exception ex){
         ex.printStackTrace();
       }
     }
   }
   
   public void loadSelectedUserSettings(){
     String filename="getUserParameterValues?uname="+cmbusernames.getSelectedItem();
     System.out.println(filename);
     String[] parameters=new String[0];
     if(!oa.isStandalone){
       try{
         BufferedReader br=new BufferedReader(new InputStreamReader(
          new URL(oa.getCodeBase(), filename).openStream()));
         String s=br.readLine();
         StringTokenizer stk=new StringTokenizer(s);
         parameters=new String[stk.countTokens()];
         if(parameters.length<sliders.length){
            System.out.println("less data in server");
            return;
         }
         for(int i=0; i<sliders.length; i++){
            sliders[i].setValue((int)(100*Double.parseDouble(stk.nextToken())));
         }
         useSliderValues();
         if(currentusername.equals(cmbusernames.getSelectedItem())){
            bsavesettings.setEnabled(true);
         }  else {
            bsavesettings.setEnabled(false);
         }
       }catch(Exception ex){
         ex.printStackTrace();
       }
      }
   }
   
   public void itemStateChanged(ItemEvent e){
      if(e.getSource()==cmbusernames){
          loadSelectedUserSettings();
      }
   }
   
   public void actionPerformed(ActionEvent e){
      if(e.getSource()==bsavesettings){
         saveSliderSettings();
      }
   }
}